import * as React from 'react';
export declare type verticalAlignType = 'top' | 'bottom';
export declare type horizontalAlignType = 'left' | 'right';
declare type positionAbsoluteParamType = number | 'auto' | null;
interface ObjectFitWrapperProps {
    children: React.ReactNode;
    ratio: number | null;
    verticalAlign?: verticalAlignType;
    horizontalAlign?: horizontalAlignType;
}
interface ObjectFitWrapperState {
    width: number | null;
    height: number | null;
    left: positionAbsoluteParamType;
    top: positionAbsoluteParamType;
}
export declare class ObjectFitWrapper extends React.PureComponent<ObjectFitWrapperProps, ObjectFitWrapperState> {
    container: React.RefObject<HTMLDivElement>;
    state: {
        width: null;
        height: null;
        left: null;
        top: null;
    };
    componentDidMount(): void;
    componentDidUpdate(prevProps: ObjectFitWrapperProps): void;
    componentWillUnmount(): void;
    getContainerDims(): {
        containerWidth: number;
        containerHeight: number;
    };
    handleResize: () => void;
    renderElement(): React.ReactElement<any>[];
    render(): JSX.Element;
}
export {};
