"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ObjectFitWrapper = /** @class */ (function (_super) {
    __extends(ObjectFitWrapper, _super);
    function ObjectFitWrapper() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.container = React.createRef();
        _this.state = {
            width: null,
            height: null,
            left: null,
            top: null,
        };
        _this.handleResize = function () {
            var _a, _b;
            var _c = _this.props, ratio = _c.ratio, verticalAlign = _c.verticalAlign, horizontalAlign = _c.horizontalAlign;
            if (ratio) {
                var containerDims = _this.getContainerDims();
                var containerWidth = containerDims.containerWidth, containerHeight = containerDims.containerHeight;
                var containerRatio = containerWidth / containerHeight;
                if (ratio > containerRatio) {
                    var newElementWidth = containerHeight * ratio;
                    var newElementLeft = horizontalAlign === 'left'
                        ? 0
                        : (containerWidth - newElementWidth) / 2;
                    _this.setState(__assign({ width: newElementWidth, height: containerHeight, top: 0, left: horizontalAlign === 'right'
                            ? 'auto'
                            : newElementLeft }, (horizontalAlign
                        ? (_a = {}, _a[horizontalAlign] = 0, _a) : {})));
                }
                else {
                    var newElementHeight = containerWidth / ratio;
                    var newElementTop = verticalAlign === 'top'
                        ? 0
                        : (containerHeight - newElementHeight) / 2;
                    var newStyle = {
                        width: containerWidth,
                        height: newElementHeight,
                    };
                    _this.setState(__assign({}, newStyle, { top: verticalAlign === 'bottom'
                            ? 'auto'
                            : newElementTop, left: 0 }, (verticalAlign
                        ? (_b = {}, _b[verticalAlign] = 0, _b) : {})));
                }
            }
        };
        return _this;
    }
    ObjectFitWrapper.prototype.componentDidMount = function () {
        window.addEventListener('resize', this.handleResize);
    };
    ObjectFitWrapper.prototype.componentDidUpdate = function (prevProps) {
        if (prevProps.ratio !== this.props.ratio) {
            this.handleResize();
        }
    };
    ObjectFitWrapper.prototype.componentWillUnmount = function () {
        window.removeEventListener('resize', this.handleResize);
    };
    ObjectFitWrapper.prototype.getContainerDims = function () {
        var _a = this.container.current, clientHeight = _a.clientHeight, clientWidth = _a.clientWidth;
        return {
            containerWidth: clientWidth,
            containerHeight: clientHeight,
        };
    };
    ObjectFitWrapper.prototype.renderElement = function () {
        var children = this.props.children;
        var style = __assign({ position: 'absolute' }, this.state);
        return React.Children.map(children, function (child) {
            return React.cloneElement(child, __assign({}, child.props, { style: style }));
        });
    };
    ObjectFitWrapper.prototype.render = function () {
        return (React.createElement("div", { style: {
                position: 'relative',
                width: '100%',
                height: '100%',
                overflow: 'hidden',
            }, ref: this.container }, this.renderElement()));
    };
    return ObjectFitWrapper;
}(React.PureComponent));
exports.ObjectFitWrapper = ObjectFitWrapper;
