"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ObjectFitWrapper_1 = require("./ObjectFitWrapper");
var Video = /** @class */ (function (_super) {
    __extends(Video, _super);
    function Video() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.video = React.createRef();
        _this.state = {
            ratio: null,
        };
        return _this;
    }
    Video.prototype.componentDidMount = function () {
        var _this = this;
        var video = this.video.current;
        video.addEventListener('loadedmetadata', function () {
            var videoWidth = video.videoWidth, videoHeight = video.videoHeight;
            _this.setState({
                ratio: videoWidth / videoHeight,
            });
        });
    };
    Video.prototype.render = function () {
        var ratio = this.state.ratio;
        var _a = this.props, verticalAlign = _a.verticalAlign, horizontalAlign = _a.horizontalAlign, children = _a.children;
        return (React.createElement(ObjectFitWrapper_1.ObjectFitWrapper, { ratio: ratio, verticalAlign: verticalAlign, horizontalAlign: horizontalAlign },
            React.createElement("video", __assign({}, this.props, { ref: this.video }), children)));
    };
    return Video;
}(React.PureComponent));
exports.Video = Video;
